package sketch.compiler.ast.core.exprs;
import sketch.compiler.ast.core.FENode;
import sketch.compiler.ast.core.FEVisitor;

/**
 * Class representing an arbitrary token or chunk of target
 * code. These will not be generated by the parser, but might
 * be emitted by processing passes just prior to output.
 * This class can be used, for example, to store a hexadecimal
 * constant.
 *
 * @author liviu
 */
public class ExprLiteral extends ExprConstant
{
	private String value;

	public ExprLiteral(FENode context, String value)
	{
		super(context);
		this.value=value;
	}

	public String getValue()
	{
		return value;
	}

	@Override
	public Object accept(FEVisitor v)
	{
		return v.visitExprLiteral(this);
	}

	public String toString()
	{
		return value;
	}
}
